// coded by Jeffrey Jestes
// jestes@cs.fsu.edu

/* prepare data set as collection of strings: string level uncertainty */

#include <fstream>
#include <iostream>
#include <vector>
#include <string>
#include <fstream>
#include <map>
#include <algorithm>
#include <cstdlib>
#include "prob_string.h"

using namespace std;


bool mysort( pair<string,double> p1, pair<string,double> p2 ) {
   return p1.second < p2.second;
}


double abs( double a  ) {
   if( a < 0 ) return -a;
   return a;
}

class tuple {
   public:
      unsigned long id;
      vector< unsigned int > id2; // id2 within id... i.e. 1 of 4
      vector<string> s;
      vector<double> prob;
      double exp_len;
};

int main( int argc, char** argv ) {

   char delim = '|';
   char eol = '\r';

   if( argc != 6 ) {
      cout << "Usage: " << argv[0] << ' ' << "<num_choices> <q> <iterations> <start_id> <all_authors_file>" << endl;
      exit( 0 );
   }


   unsigned int choices = atoi( argv[1] );
   unsigned int norm_choices;
   unsigned int rand_choices;
   unsigned int q = atoi( argv[2] );
   unsigned int iterations = atoi( argv[3] );
   unsigned int start_id = atoi( argv[4] );
   
   fstream fin( argv[5] );

   vector<string> allnames;
   string s;
   unsigned long temp;
   while( getline( fin, s, '\r') ) {
      allnames.push_back( s );
      if( fin.peek() == '\n' ) fin.get();
   }
 
   vector< tuple > t;
   vector< string > mnames;

   srand( time(0 ) );

   string name;
   unsigned int count;
   unsigned long id = 0;
   unsigned long new_id = 1;
   unsigned long next_id = 0;
   cin >> id;
   for( count = 0; count < iterations; ++count ){
      name.clear();
      mnames.clear();

//      cout << "id: " << id << endl;
      char dummy;
      cin >> dummy;
      char buf[1000];
      cin.getline( buf, 1000, delim );
      int buf_i;

      name = string( buf );
//      cout << "name: " << buf << ' ' << name << endl;
      mnames.resize( 1 );
      cin.getline( buf, 1000, eol );
      mnames.back() = string( buf );
//      cout << "mname: " << buf << ' ' << mnames.back() << endl;


      while( cin >> next_id && id == next_id ) {
         cin >> dummy;
         cin.getline( buf, 1000, delim );
         cin.getline( buf, 1000, eol );

         mnames.push_back( string(buf) );
//         cout << "mname: " << buf << ' ' << mnames.back() << endl;
      }

      map< string, double > m;
      map< string, double >::iterator it;
      for( unsigned int i = 0; i < mnames.size(); ++i ) {
         it = m.find( mnames[i] );
         if( it != m.end() ) {
            it->second = it->second +1;
         }
         else {
            m.insert( pair< string, unsigned int >( mnames[i], 1 ) );
         }
      }

      vector< pair<string, double > > m_sort;
      for( it = m.begin(); it != m.end(); ++it ) {
         m_sort.push_back( *it );
      }

      sort( m_sort.begin(), m_sort.end(), mysort );

      map< double, int > m2;
      map< double, int >::iterator it2;
      for( unsigned int i = 0; i < m_sort.size(); ++i ) {
         it2 = m2.find( m_sort[i].second );
         if( it2 != m2.end() ) {
            it2->second = it2->second+1;
         }
         else {
            m2.insert( pair<double,int>( m_sort[i].second, 1 ) );
         }
      }

      for( unsigned int i = 0; i < m_sort.size(); ) {
         it2 = m2.find( m_sort[i].second );
         if( it2->second > 1 ) {
            double sum = 0;
            for( unsigned int j = i; j < it2->second + i; ++j ) {
               m_sort[j].second = ( rand() % 100 ) + 1;
               sum += m_sort[j].second;
            }
            for( unsigned int j = i; j < it2->second + i; ++j ) {
               m_sort[j].second /= sum;
               m_sort[j].second *= it2->first * it2->second;
            }
         }
         i += it2->second;
      }


      m.clear();
      for( unsigned int i = 0; i < m_sort.size(); ++i ) {
         m.insert( m_sort[i] );
      }
      m_sort.clear();

      for( it = m.begin(); it != m.end(); ++it ) {
         it->second /= mnames.size();
      }

      if( m.size() == 1 ) { norm_choices = 1; rand_choices = choices / 2; }
      else if( m.size() > 1 ) {
         if( m.size() >= choices ) {
            norm_choices = choices / 2;
            rand_choices = choices - norm_choices;
         }
         else {
            norm_choices = m.size() / 2;
            rand_choices = choices / 2;
         }
      }


      double rem = 0;
      while( m.size() > norm_choices ) {
         double min = 2;
         string s;
         for( it = m.begin(); it != m.end(); ++it ) {
            if( it->second < min ) { 
               min = it->second;
               s = it->first;
            }
         }
         rem += min;
         it = m.find( s );
         m.erase( it );
      }

      if( rem > 0 && rand_choices > 0 ) {
         for( it = m.begin(); it != m.end(); ++it ) {
            it->second = ( it->second / ( 1 - rem ) ) * 0.5;
         }
      }
      else {
         for( it = m.begin(); it != m.end(); ++it ) {
            it->second = ( it->second / ( 1 - rem ) );
         }
      }

            
      if( rem == 0 && rand_choices > 0 ) {
         rem = 0.5;
         for( it = m.begin(); it != m.end(); ++it ) {
            it->second /= 2;
         }
      }

/*
      int min_len = 100;
      for( it = m.begin(); it != m.end(); ++it ) {
         if( it->first.size() < min_len ) {
            min_len = it->first.size();
         }
      }
*/
      rem = 0.5;

      int temp = m.size();             
      double sum = 0;
      while( m.size() + m_sort.size() < temp + rand_choices ) {
         string s = allnames[ rand() % allnames.size() ];
//         while( s.size() > min_len ) s = allnames[ rand() % allnames.size() ];
         double rt = ( rand() % 100 ) + 1;
         sum+=rt;
         m_sort.push_back( pair<string,double>( s, rt ) );
      } 

      for( unsigned int i = 0; i < m_sort.size(); ++i ) {
         m_sort[i].second /= sum;
         m_sort[i].second *= rem;
         m.insert( m_sort[i] );
      }



/*
      if( rem > 0 ) {
         for( it = m.begin(); it != m.end(); ++it ) {
            it->second /= ( 1 - rem );
         }
      }
*/
      double exp_len = 0;
      for( it = m.begin(); it != m.end(); ++it ) {
         exp_len += it->first.size() * it->second;
      }

      
      tuple ti;
      ti.id = start_id++;
      unsigned int id2 = 1;
      for( it = m.begin(); it != m.end(); ++it ) {
         ti.s.push_back( it->first );
         ti.prob.push_back( it->second );
         ti.id2.push_back( id2++ );
         ti.exp_len = exp_len;
      }

      t.push_back( ti );
      

      id = next_id;
   }

   for( unsigned int i = 0; i < t.size(); ++i ) {
      for( unsigned int j = 0; j < t[i].s.size(); ++j ) {
         cout << t[i].id << "\t" << t[i].id2[j] << "\t" << t[i].exp_len << "\t" << t[i].prob[j] << "\t" << t[i].s[j] << "\r\n";
         
         vector< vector<char> > grams;
         prob_string x;
         if( q == 3 ) x.QGRAMS3( t[i].s[j], grams );
         else if( q == 4 ) x.QGRAMS4( t[i].s[j], grams );
         else x.QGRAMS( t[i].s[j], grams );
         for( unsigned int k = 0; k < grams.size(); ++k ) {
            cerr << t[i].id << "\t" << t[i].id2[j] << "\t" << k  << "\t";
            for( unsigned int l = 0; l < grams[k].size(); ++l ) {
               cerr << grams[k][l];
            }
            cerr << "\t" << t[i].exp_len << "\t" << t[i].prob[j] << "\r\n";
         }
      }
   }

   return 0;
}
