// coded by Jeffrey Jestes
// jestes@cs.fsu.edu

/* prepare data set with uncertain characters: character-level uncertainty
   tuple lines end with "\r\n" */

#include <iostream>
#include <vector>
#include <string>
#include <fstream>
#include <cstdlib>
#include <map>
#include "prob_string.h"

using namespace std;


double abs( double a  ) {
   if( a < 0 ) return -a;
   return a;
}

int main( int argc, char** argv ) {

   char delim = '|';
   char eol = '\r';

   if( argc != 7 ) {
      cout << "Usage: " << argv[0] << ' ' << "<percent_random_var> <q> <iterations> <start_id> <xdegree> <concat>" << endl;
      exit( 0 );
   }


   double percent_random_var = atof( argv[1] );
   unsigned int q = atoi( argv[2] );
   unsigned int iterations = atoi( argv[3] );
   unsigned int start_id = atoi( argv[4] );
   unsigned int xdegree = atoi( argv[5] );
   unsigned int concat = atoi( argv[6] );

   vector<prob_string> v;
   vector<int> v_length;
   string lname;
   vector< string > mnames;

   srand( time(0 ) );

   string name;
   unsigned int count;
   unsigned long id = 0;
   unsigned long new_id = 1;
   unsigned long next_id = 0;
   cin >> id;
   for( count = 0; count < iterations; ++count ){
      name.clear();
      mnames.clear();

//      cout << "id: " << id << endl;
      char dummy;
      cin >> dummy;
      char buf[1000];
      cin.getline( buf, 1000, delim );
      name = string( buf );
      for( int c_count = 0; c_count < concat; ++c_count ) name += string(buf);
      v_length.push_back( name.size() );
//      cout << "name: " << buf << ' ' << name << endl;
      mnames.resize( 1 );
      cin.getline( buf, 1000, eol );
      mnames.back() = string( buf );
      for( int c_count = 0; c_count < concat; ++c_count ) mnames.back() += string(buf);

//      cout << "mname: " << buf << ' ' << mnames.back() << endl;


      while( cin >> next_id && id == next_id ) {
         cin >> dummy;
         cin.getline( buf, 1000, delim );
         cin.getline( buf, 1000, eol );
         mnames.push_back( string(buf) );
         for( int c_count = 0; c_count < concat; ++c_count ) mnames.back() += string(buf);
//         cout << "mname: " << buf << ' ' << mnames.back() << endl;
      }
      id = next_id;

      if( name.size() < 1 ) break;


      random_var rset[name.size()];
      bool placed[name.size()];
      unsigned long num_random = ( percent_random_var * (double) name.size() ) + 0.9;
      if( num_random > 3 ) num_random = 3;
      if( num_random == 0 ) num_random = 1;
      double sum = 0;
      double prob = 0;
      for( unsigned int j = 0; j < name.size(); ++j ) {
         placed[j] = false;
      }
      for( unsigned int j = 0; j < name.size(); ++j ) {
         rset[j] = random_var( name[j] );
      }

      for( unsigned int j = 0; j < num_random; ++j ) {
         int toplace = rand() % name.size();
         while( placed[toplace] ) {
            toplace = rand() % name.size();
         }
         placed[toplace] = true;
         rset[toplace] = random_var();



         int total = 0;
         map< char, double > m;
         map< char, double >::iterator it;
         for( unsigned int k = 0; k < mnames.size(); ++k ) {
            if( toplace < mnames[k].size() ) {
               ++total;
               it = m.find( mnames[k][toplace] );
               if( it != m.end() ) {
                  it->second = it->second +1;
               }
               else {
                  m.insert( pair< char, unsigned int >( mnames[k][toplace], 1 ) );
               }
            }
         }

         for( it = m.begin(); it != m.end(); ++it ) {
            it->second /= (double) total;
         }

         double rem = 0;
         while( m.size() > xdegree) {
            double min = 2;
            char s;
            for( it = m.begin(); it != m.end(); ++it ) {
               if( it->second < min ) {
                  min = it->second;
                  s = it->first;
               }
            }
            rem += min;
            it = m.find( s );
            m.erase( it );
         }

         if( rem > 0 ) {
            for( it = m.begin(); it != m.end(); ++it ) {
               it->second /= ( 1 - rem );
            }
         }  

 

         for( it = m.begin(); it != m.end(); ++it ) {
            rset[toplace].v.push_back( instance( it->first, it->second )  );  
         }
      }

      v.push_back( prob_string() );

      for( unsigned int j = 0; j < name.size(); ++j ) {
         v.back().ps.push_back( rset[j] );
      }

   }

   unsigned int start_key = start_id;
   for( unsigned int i = 0; i < v.size(); ++i, ++start_key ) {
      cout << start_key << "\t" << v_length[i] << "\t";
      v[i].printSQL();
      v[i].printQGRAM(start_key, q, v_length[i] );
   }

   return 0;
}
