// Coded by Jeffrey Jestes
// jestes@cs.fsu.edu

// Edit Distance UDFs

#include "stdafx.h"
#include "PED.h"

using namespace System;
using namespace System::Data;
using namespace System::Data::Sql;
using namespace System::Data::SqlTypes;
using namespace Microsoft::SqlServer::Server;

// In order to debug your Aggregate, add the following to your debug.sql file:
//
// select dbo.MyUDF()
// go


public ref class instance {
   public:
      Char c;
      double prob;
      instance() {
         c = 0;
         prob = 0;
      }
      instance( Char c, double prob ) {
         this->c = c;
         this->prob = prob;
      }
	  instance( const instance^ i ) {
		  this->c = i->c;
		  this->prob = i->prob;
	  }

	  instance^ operator=( const instance^ i ) {
		  this->c = i->c;
		  this->prob = i->prob;

		  return this;
	  }
};


public ref class random_var {
   public:
	   int curr;
	   int prev;
      List<instance^>^ v;
      random_var() {
		  curr = 0;
         v = gcnew List<instance^>();
      };
      random_var( Char c ) {
		  curr = 0;
		  v = gcnew List<instance^>();
         v->Add( gcnew instance( c, 1 ) );
      }
	  random_var( const random_var^ r ) {
		  curr = 0;
		  v = gcnew List<instance^>();
		  for( int i = 0; i < r->v->Count; ++i ) {
			  v->Add( gcnew instance( r->v[i] ) );
		  }
	  }
      ~random_var() {
		  this->v->Clear();
      }

	  void push_back( Char c, double p ) {
		  v->Add( gcnew instance( c, p ) );
	  }

      bool contains( Char c ) {
         for( int i = 0; i < v->Count; ++i ) {
            if( v[i]->c == c ) return true;
         }
         return false;
      }

      random_var^ operator=( const random_var^ r ) {
         this->v->Clear();
		 curr = r->curr;
         for( int i = 0; i < r->v->Count; ++i ) {
			 this->v->Add( gcnew instance( r->v[i] ) );
         }
         return this;
      }
};

public ref class prob_string {
   public:
	   List<random_var^>^ ps;
      prob_string() {
		  ps = gcnew List<random_var^>();
	  }
      prob_string( Char c ) {
		  ps = gcnew List<random_var^>();
         ps->Add( gcnew random_var( c ) );
      }
      prob_string( prob_string^ p ) {
		  ps = gcnew List<random_var^>();
		  for( int i = 0; i < p->ps->Count; ++i ) {
			  ps->Add( gcnew random_var( p->ps[i] ) );
		  }
      }
      prob_string^ operator=( const prob_string^ p ) {
		  ps->Clear();
		  for( int i = 0; i < p->ps->Count; ++i ) {
			  ps->Add( gcnew random_var( p->ps[i] ) );
		  }

		 return this;
      }

	  void push_back( random_var^ r ) {
		  ps->Add( gcnew random_var( r ) );
	  }

	  prob_string^ to_prob_string( SqlTypes::SqlString s ) {
		  array<Char>^ ss = s.ToString()->ToCharArray();

		  prob_string^ result = gcnew prob_string();
		  random_var^ temp = gcnew random_var();
		  bool no_prob = false;
		  double d = 0;
		  int count = 1;
		  Char c = 0;
		  for( int i = 0; i < ss->Length; ) {
			  if( ss[i] == Char('|') ) {
				  if( no_prob == true ) {
					  temp->push_back( c, 1 );
				  }
				  count = 1;
				  d = 0;
				  c = 0;
				  no_prob = true;
				  result->push_back( temp );
				  temp = gcnew random_var();
				  ++i;
			  }
			  else if( ss[i] == Char('#') ) {
				  no_prob = false;
				  i += 3; // $0.
				  while( i < ss->Length ) {
					  if( ss[i] == Char('#') ) {
						  d /= count;
						  temp->push_back( c, d );
						  d = 0;
						  count = 1;
						  ++i;
						  break;
					  }
					  else {
						  d *= 10;
						  d += (ss[i] - Char('0'));
						  count *= 10;
						  ++i;
					  }
				  }
			  }
			  else {
				  c = (Char) ss[i];
				  no_prob = true;
				  ++i;
			  }
		  }
		  return result;
	  }

      void clear() {
         ps->Clear();
      }

	  void enumerate( List< List<Char>^ >^ worlds, List<double>^ prob ) {
		  worlds->Add( gcnew List<Char>() );
		  prob->Add(1);

		  int orig_size = 0;

		  for( int i = 0; i < ps->Count; ++i ) {

             if( ps[i]->v->Count == 1 ) {
				 for( int j = 0; j < worlds->Count; ++j ) {
					 worlds[j]->Add( ps[i]->v[0]->c );
                   prob[j] *= ps[i]->v[0]->prob;
                }
             }
             else if( ps[i]->v->Count > 1 ) {
                orig_size = worlds->Count;
                
                // copy the original worlds by the number of choices in the current random var
                for( int j = 0; j < orig_size; ++j ) {
                   for( int k = 0; k < ps[i]->v->Count - 1; ++k ) {
					   List<Char>^ temp = gcnew List<Char>();
					   for( int l = 0; l < worlds[j]->Count; ++l ) {
						   temp->Add( worlds[j][l] );
					   }
					   worlds->Add( temp );
                      prob->Add( prob[j] );
                   }
                }

                for( int j = 0; j < orig_size; ++j ) {
                   worlds[j]->Add( ps[i]->v[0]->c );
                   prob[j] *= ps[i]->v[0]->prob;
                }
                for( int j = orig_size; j < worlds->Count; ) {
                   for( int k = 1; k < ps[i]->v->Count; ++k, ++j ) {
                      worlds[j]->Add( ps[i]->v[k]->c );
                      prob[j] *= ps[i]->v[k]->prob;
                   }
                }
             } // end else
          } // end for
       } // end enumerate

  
             
};
           
public ref class ED {
public:
	unsigned int LevenshteinDistance( List<Char>^ s, List<Char>^ t ) {
		array<unsigned int, 2>^ d = gcnew array<unsigned int, 2>( s->Count + 1,t->Count + 1);

		for( int i = 0; i < s->Count + 1; i++ ) {
	      d[i,0] = i;
		}
		for( int i = 0; i < t->Count + 1; i++ ) {
		    d[0,i] = i;
		}

		unsigned int cost = 0;
		unsigned int min = 0;
		int i, j;
		for( i = 1; i < s->Count + 1; ++i ) {
			for( j = 1; j < t->Count + 1; ++j ) {

			   if( s[i-1] == t[j-1] ) {
				   cost = 0;
			   }
			   else cost = 1;

			   // find the minimum
			   min = d[i-1,j] + 1;
			   if( ( d[i,j-1] + 1 ) < min ) min = d[i,j-1] + 1;
			   if( ( d[i-1,j-1] + cost ) < min ) min = d[i-1,j-1] + cost;
			   d[i,j] = min; 
			}
   		}

		return d[i-1,j-1];
	}

	double ExactExpectedDistance2( prob_string^ s, prob_string^ t ) {

		List<Char>^ sc = gcnew List<Char>();
		List<Char>^ tc = gcnew List<Char>();
		int si = s->ps->Count - 1;
		int ti = t->ps->Count - 1;
		int curr_si = -1;
		int curr_ti = -1;
		int fsi = -1;
		int fti = -1;
		double ps = 1;
		double pt = 1;
		unsigned int edit;
		double pw = 0;
		double expectance = 0;
		bool dones = false;
		bool donet = false;

		int previ = -1;
		for( int i = 0; i < s->ps->Count; ++i ) {
			s->ps[i]->prev = previ;
			if( s->ps[i]->v->Count > 1 && fsi == -1 ) {
				fsi = i;
			}
			if( s->ps[i]->v->Count > 1 ) {
				previ = i;
			}
		}
		previ = -1;
		for( int i = 0; i < t->ps->Count; ++i ) {
			t->ps[i]->prev = previ;
			if( t->ps[i]->v->Count > 1 && fti == -1 ) {
				fti = i;
			}
			if( t->ps[i]->v->Count > 1 ) {
				previ = i;
			}
		}

		int total = 0;

		while( true ) {
			ps = 1;
			si = -1;
			for( int i = 0; i < s->ps->Count; ++i ) {
				sc->Add( s->ps[i]->v[s->ps[i]->curr]->c );
				ps *= s->ps[i]->v[s->ps[i]->curr]->prob;
				if( s->ps[i]->v->Count > 1 ) si = i;
			}
			if( si != -1 ) {
				for( int i = si; i >= 0; ) {
					s->ps[i]->curr++;
					if( s->ps[i]->curr > s->ps[i]->v->Count - 1 ) {
						if( i == fsi ) {
							s->ps[i]->curr = 0;
							dones = true;
							break;
						}
						s->ps[i]->curr = 0;
						i = s->ps[i]->prev;
					}
					else break;
				}
			}

			donet = false;
			while( true ) {
				pt = 1;
				ti = -1;
				for( int i = 0; i < t->ps->Count; ++i ) {
					tc->Add( t->ps[i]->v[t->ps[i]->curr]->c );
					pt *= t->ps[i]->v[t->ps[i]->curr]->prob;
					if( t->ps[i]->v->Count > 1 ) ti = i;

				}

		
				if( ti != -1 ) {
					for( int i = ti; i >= 0; ) {
						t->ps[i]->curr++;
						if( t->ps[i]->curr > t->ps[i]->v->Count - 1 ) {
							if( i == fti ) {
								t->ps[i]->curr=0;
								donet = true;
								break;
							}
							t->ps[i]->curr = 0;
							i = t->ps[i]->prev;
						}
						else break;
					}
				}


				edit = LevenshteinDistance( sc, tc );
				pw = ps * pt;
				expectance += ( pw * edit );

				tc->Clear();

				total++;

				if( donet == true || fti == -1 ) break;
			}

			sc->Clear();

			if( dones == true || fsi == -1 ) break;

		}

		return expectance;
	}



	
	double ExactExpectedDistance( List< List<Char>^ >^ v, List< List<Char>^ >^ v2, List<double>^ p, List<double>^ p2 )
	{
		unsigned int edit = 0;
		double pw = 0;
		double expectance = 0;
		for( int j = 0; j < v->Count; ++j ) {
			for( int k = 0; k < v2->Count; ++k ) {

				edit = LevenshteinDistance( v[j], v2[k] );
				pw = p[j] * p2[k];
				expectance += ( edit * pw);
			}
		}
		return expectance;
	}



	double probdiff( random_var^ a, random_var^ b ) {
		double prob = 0;
		for( int i = 0; i < a->v->Count; ++i ) {
			for( int j = 0; j < b->v->Count; ++j ) {
				if( a->v[i]->c != b->v[j]->c ) {
					prob += ( a->v[i]->prob * b->v[j]->prob );         
				}
			}
		}
		return prob;
	}

	// true if cost is zero in a possible world
	bool cost_zero( random_var^ a, random_var^ b ) {
   		for( int i = 0; i < a->v->Count; ++i ) { 
			for( int j = 0; j < b->v->Count; ++j ) {
				if( a->v[i]->c == b->v[j]->c ) {
					return true;
				}
			}
		}
		return false;
	}

	// true if cost is one in a possible world
	bool cost_1( random_var^ a, random_var^ b ) {
		if( a->v->Count > 1 || b->v->Count > 1 ) return true;
		else if( a->v->Count == 1 && b->v->Count == 1 && a->v[0]->c == b->v[0]->c ) return false;
		else return true;
	}

	unsigned int MinEditDistance( prob_string^ s, prob_string^ t ) {
		array<unsigned int, 2>^ d = gcnew array<unsigned int, 2>( s->ps->Count + 1, t->ps->Count + 1 );

		for( int i = 0; i < s->ps->Count + 1; i++ ) {
			d[i,0] = i;
		}
		for( int i = 0; i < t->ps->Count + 1; i++ ) {
			d[0,i] = i;
		}

		unsigned int cost = 0;
		unsigned int min = 0;
		int i, j;
		for( i = 1; i < s->ps->Count + 1; ++i ) {
			for( j = 1; j < t->ps->Count + 1; ++j ) {      
				if( cost_zero( s->ps[i-1], t->ps[j-1] ) == true ) cost = 0;
				else cost = 1;

				// find the minimum     
				min = d[i-1,j] + 1; 
				if( ( d[i,j-1] + 1 ) < min ) min = d[i,j-1] + 1;
				if( ( d[i-1,j-1] + cost ) < min ) min = d[i-1,j-1] + cost;
				d[i,j] = min;
			}
		}
		return d[i-1,j-1];
	}

	// returns an approximation
	unsigned int MaxEditDistance( prob_string^ s, prob_string^ t ) {
		array<unsigned int, 2>^ d = gcnew array<unsigned int, 2>( s->ps->Count + 1, t->ps->Count + 1 );

		for( int i = 0; i < s->ps->Count + 1; i++ ) {
			d[i,0] = i;
		}
		for( int i = 0; i < t->ps->Count + 1; i++ ) {
			d[0,i] = i;
		}

		unsigned int cost = 0;
		unsigned int min = 0;
		int i, j;
		for( i = 1; i < s->ps->Count + 1; ++i ) {
			for( j = 1; j < t->ps->Count + 1; ++j ) {      
				if( cost_1( s->ps[i-1], t->ps[j-1] ) == true ) cost = 1;
				else cost = 0;

				// find the minimum     
				min = d[i-1,j] + 1; 
				if( ( d[i,j-1] + 1 ) < min ) min = d[i,j-1] + 1;
				if( ( d[i-1,j-1] + cost ) < min ) min = d[i-1,j-1] + cost;
				d[i,j] = min;
			}
		}
		return d[i-1,j-1];
	}


double lbqgramdp( int q, prob_string^ s, prob_string^ t ) {

	int max_l;
	if( s->ps->Count > t->ps->Count ) max_l = s->ps->Count;
	else max_l = t->ps->Count;

   prob_string^ s2 = gcnew prob_string();
   prob_string^ t2 = gcnew prob_string();


   for( int i = 0; i < q - 1; ++i ) {
	   s2->ps->Add( gcnew random_var( Char('$') ) );
	   t2->ps->Add( gcnew random_var( Char('$') ) );
   }
   for( int i = 0; i < s->ps->Count; ++ i ) {
	   s2->ps->Add( gcnew random_var( s->ps[i] ) );
   }
   for( int i = 0; i < t->ps->Count; ++i ) {
	   t2->ps->Add( gcnew random_var( t->ps[i] ) );
   }
   for( int i = 0; i < q - 1; ++i ) {
	   s2->ps->Add( gcnew random_var( Char('#') ) );
	   t2->ps->Add( gcnew random_var( Char('#') ) );
   }

   int ssize = s->ps->Count + q - 1;
   int tsize = t->ps->Count + q - 1;
   array<int, 2>^ F = gcnew array<int, 2>( ssize, tsize );
   array<int, 2>^ f = gcnew array<int, 2>( ssize, tsize );

   int max = 0;
   for( int i = 0; i < ssize; ++i ) {
      int b = 1;
      int k = i;
      int l = 0;
      for( ; k < i+q; ++k, ++l ) {
         if( cost_zero( s2->ps[k], t2->ps[l] ) == false ) {
            b = 0;
            break;
         }
      }
      if( b > max ) max = b;
      f[i,0] = b;
      F[i,0] = max;
   }

   max = 0;
   for( int i = 0; i < tsize; ++i ) {
      int b = 1;
      int k = i;
      int l = 0;
      for( ; k < i+q; ++k, ++l) {
         if( cost_zero( s2->ps[l], t2->ps[k] ) == false ) {
            b = 0;
            break;
         }
      }
      if( b > max ) max = b;
      f[0,i] = b;
      F[0,i] = max;
   }

      
   for( int i = 1; i < ssize; ++i ) {
      for( int j = 1; j < tsize; ++j ) {
         max = F[ i - 1,j];
         if( F[i,j-1] > max ) max = F[i,j-1];



         int b = 1;
         int k = i;
         int l = j;
         for( ; k < i+q; ++k, ++l ) {
            if( cost_zero( s2->ps[k], t2->ps[l] ) == false ) {
               b = 0;
               break;
            }
         }

         int pmax = b;
         if( b > 0 ) {
            if( i - q >= 0 && j - q >= 0 ) pmax = F[i-q,j-q] + 1;
			if( i - 1 >= 0 && j - 1 >= 0 && f[i-1,j-1] + 1 > pmax ) pmax = f[i-1,j-1] + 1;
         }

         if( b * pmax > max ) max = b * pmax;
         F[i,j] = max;
         f[i,j] = b * pmax;

      } // end for j
   }  // end for i


   double result = max_l - F[ssize-1,tsize-1] - 1 + q;
   result /= q;

   if( result < 0 ) result = 0;

   return result;
}


	// the cost is the probability that two probabilistic characters are different
	double EEDUpperBound( prob_string^ s, prob_string^ t ) {
		array<double, 2>^ d = gcnew array<double, 2>( s->ps->Count + 1, t->ps->Count + 1 );
  
		for( int i = 0; i < s->ps->Count + 1; i++ ) {
			d[i,0] = i;
		}
		for( int i = 0; i < t->ps->Count + 1; i++ ) {
			d[0,i] = i;
		}

		double cost = 0;   
		double min = 0;
		int i, j;
		for( i = 1; i < s->ps->Count + 1; ++i ) {
			for( j = 1; j < t->ps->Count + 1; ++j ) {
				cost = probdiff( s->ps[i-1], t->ps[j-1] );

				// find the minimum
				min = d[i-1,j] + 1;
				if( ( d[i,j-1] + 1 ) < min ) min = d[i,j-1] + 1;
				if( ( d[i-1,j-1] + cost ) < min ) min = d[i-1,j-1] + cost;
				d[i,j] = min;      
			}
		}
		return d[i-1,j-1];
	}
};




public ref class AddNewUDF 
{    
public:


	[Microsoft::SqlServer::Server::SqlFunction]
	static SqlTypes::SqlInt32 worlds( SqlTypes::SqlString s, SqlTypes::SqlString t ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );

		  int s2_worlds = 1;
		  for( int i = 0; i < s2->ps->Count; ++ i ) {
			  s2_worlds *= s2->ps[i]->v->Count;
		  }

		  int t2_worlds = 1;
		  for( int i = 0; i < t2->ps->Count; ++i ) {
			  t2_worlds *= t2->ps[i]->v->Count;
		  }

		  return s2_worlds * t2_worlds;
	}

	[Microsoft::SqlServer::Server::SqlFunction]
	static SqlTypes::SqlInt32 maxx( SqlTypes::SqlString s) {
		  prob_string^ s2 = s2->to_prob_string( s );

		  int s2_max = -1;
		  for( int i = 0; i < s2->ps->Count; ++ i ) {
			  if( s2->ps[i]->v->Count > s2_max ) s2_max = s2->ps[i]->v->Count;
		  }

		  return s2_max;
	}

		[Microsoft::SqlServer::Server::SqlFunction]
	static SqlTypes::SqlInt32 choice( SqlTypes::SqlString s) {
		  prob_string^ s2 = s2->to_prob_string( s );

		  int s2_choice = 0;
		  for( int i = 0; i < s2->ps->Count; ++ i ) {
			  if( s2->ps[i]->v->Count > 1 ) s2_choice++;
		  }

		  return s2_choice;
	}

	[Microsoft::SqlServer::Server::SqlFunction]
	static SqlTypes::SqlInt32 worlds2( SqlTypes::SqlString s, SqlTypes::SqlString t ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );

		  int s2_worlds = s2->ps->Count;
		  for( int i = 0; i < s2->ps->Count; ++ i ) {
			  s2_worlds *= s2->ps[i]->v->Count;
		  }

		  int t2_worlds = t2->ps->Count;
		  for( int i = 0; i < t2->ps->Count; ++i ) {
			  t2_worlds *= t2->ps[i]->v->Count;
		  }

		  return s2_worlds * t2_worlds;
	}


	[Microsoft::SqlServer::Server::SqlFunction]
	static SqlTypes::SqlInt32 dist( SqlTypes::SqlString s, SqlTypes::SqlString t ) {

		array<Char>^ sarray = s.ToString()->ToCharArray();
		array<Char>^ tarray = t.ToString()->ToCharArray();
		List<Char>^ s2 = gcnew List<Char>();
		List<Char>^ t2 = gcnew List<Char>();
		for( int i = 0; i < sarray->Length; ++i ) {
			s2->Add( sarray[i] );
		}
		for( int i = 0; i < tarray->Length; ++i ) {
			t2->Add( tarray[i] );
		}
		  
		  ED d;
		  return d.LevenshteinDistance( s2, t2 );
	}

	// Memory intensive: may cause thrasing but generally faster than EED1X
	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble EED1( SqlTypes::SqlString s, SqlTypes::SqlString t ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;


		  List< List<Char>^ >^ worlds_s = gcnew List< List<Char>^ >();
		  List<double>^ prob_s = gcnew List<double>();
		  List< List<Char>^ >^ worlds_t = gcnew List< List<Char>^ >();
		  List<double>^ prob_t = gcnew List<double>();

		  s2->enumerate( worlds_s, prob_s );
		  t2->enumerate( worlds_t, prob_t );
		  
		  return d.ExactExpectedDistance( worlds_s, worlds_t, prob_s, prob_t );
	}

	  // Slower but doesn't cause thrasing ( hence faster on some data sets )
	  	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble EED1X( SqlTypes::SqlString s, SqlTypes::SqlString t ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;

		  
		  return d.ExactExpectedDistance2( s2, t2 );
	}

	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble EED2( SqlTypes::SqlString s, SqlTypes::SqlString t, int k ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		  if( d.EEDUpperBound( s2, t2 ) < (unsigned int) k )
			  return 0;
		  /*
		  else if( d.MinEditDistance( s2, t2 ) > (unsigned int) k )
			  return k + 1;
		  */


		  List< List<Char>^ >^ worlds_s = gcnew List< List<Char>^ >();
		  List<double>^ prob_s = gcnew List<double>();
		  List< List<Char>^ >^ worlds_t = gcnew List< List<Char>^ >();
		  List<double>^ prob_t = gcnew List<double>();

		  s2->enumerate( worlds_s, prob_s );
		  t2->enumerate( worlds_t, prob_t );
		  
		  return d.ExactExpectedDistance( worlds_s, worlds_t, prob_s, prob_t );
	}

	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble EED3( SqlTypes::SqlString s, SqlTypes::SqlString t, int k ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		  if( d.EEDUpperBound( s2, t2 ) < (unsigned int) k || d.MaxEditDistance(s2, t2 ) < (unsigned int) k )
			  return 0;
		  /*
		  else if( d.MinEditDistance( s2, t2 ) > (unsigned int) k )
			  return k + 1;
		  */


		  List< List<Char>^ >^ worlds_s = gcnew List< List<Char>^ >();
		  List<double>^ prob_s = gcnew List<double>();
		  List< List<Char>^ >^ worlds_t = gcnew List< List<Char>^ >();
		  List<double>^ prob_t = gcnew List<double>();

		  s2->enumerate( worlds_s, prob_s );
		  t2->enumerate( worlds_t, prob_t );
		  
		  return d.ExactExpectedDistance( worlds_s, worlds_t, prob_s, prob_t );
	}

	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble EED4( SqlTypes::SqlString s, SqlTypes::SqlString t, int k ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		  if( d.EEDUpperBound( s2, t2 ) < (unsigned int) k )
			  return 0;
		  else if( d.MinEditDistance( s2, t2 ) > (unsigned int) k )
			  return k + 1;


		  List< List<Char>^ >^ worlds_s = gcnew List< List<Char>^ >();
		  List<double>^ prob_s = gcnew List<double>();
		  List< List<Char>^ >^ worlds_t = gcnew List< List<Char>^ >();
		  List<double>^ prob_t = gcnew List<double>();

		  s2->enumerate( worlds_s, prob_s );
		  t2->enumerate( worlds_t, prob_t );
		  
		  return d.ExactExpectedDistance( worlds_s, worlds_t, prob_s, prob_t );
	}

	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble EED5( SqlTypes::SqlString s, SqlTypes::SqlString t, int k ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		 if( d.MinEditDistance( s2, t2 ) > (unsigned int) k )
			  return k + 1;
		 /*
		  if( d.EEDUpperBound( s2, t2 ) < (unsigned int) k )
			  return 0;
			  */



		  List< List<Char>^ >^ worlds_s = gcnew List< List<Char>^ >();
		  List<double>^ prob_s = gcnew List<double>();
		  List< List<Char>^ >^ worlds_t = gcnew List< List<Char>^ >();
		  List<double>^ prob_t = gcnew List<double>();

		  s2->enumerate( worlds_s, prob_s );
		  t2->enumerate( worlds_t, prob_t );
		  
		  return d.ExactExpectedDistance( worlds_s, worlds_t, prob_s, prob_t );
	}


	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble EED6( SqlTypes::SqlString s, SqlTypes::SqlString t, int k ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		 if( d.MinEditDistance( s2, t2 ) > (unsigned int) k )
			  return k + 1;
		 if( d.EEDUpperBound( s2, t2 ) < (unsigned int) k )
			  return k+1;






		  List< List<Char>^ >^ worlds_s = gcnew List< List<Char>^ >();
		  List<double>^ prob_s = gcnew List<double>();
		  List< List<Char>^ >^ worlds_t = gcnew List< List<Char>^ >();
		  List<double>^ prob_t = gcnew List<double>();

		  s2->enumerate( worlds_s, prob_s );
		  t2->enumerate( worlds_t, prob_t );
		  
		  return d.ExactExpectedDistance( worlds_s, worlds_t, prob_s, prob_t );
	}

	  	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble LB( SqlTypes::SqlString s, SqlTypes::SqlString t ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		  return d.MinEditDistance( s2, t2 );

	}

	  	  	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble UB( SqlTypes::SqlString s, SqlTypes::SqlString t ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		  return d.EEDUpperBound( s2, t2 );
	}


	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble EED7( SqlTypes::SqlString s, SqlTypes::SqlString t, int k ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		 if( d.lbqgramdp( 2, s2, t2 ) > (unsigned int) k )
			  return k + 1;
		  if( d.EEDUpperBound( s2, t2 ) < (unsigned int) k )
			  return 0;




		  List< List<Char>^ >^ worlds_s = gcnew List< List<Char>^ >();
		  List<double>^ prob_s = gcnew List<double>();
		  List< List<Char>^ >^ worlds_t = gcnew List< List<Char>^ >();
		  List<double>^ prob_t = gcnew List<double>();

		  s2->enumerate( worlds_s, prob_s );
		  t2->enumerate( worlds_t, prob_t );
		  
		  return d.ExactExpectedDistance( worlds_s, worlds_t, prob_s, prob_t );
	}

	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble EED8( SqlTypes::SqlString s, SqlTypes::SqlString t, int k ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		  if( d.EEDUpperBound( s2, t2 ) < (unsigned int) k )
			  return 0;
		  if( d.lbqgramdp( 2, s2, t2 ) > (unsigned int) k )
			  return k + 1;




		  List< List<Char>^ >^ worlds_s = gcnew List< List<Char>^ >();
		  List<double>^ prob_s = gcnew List<double>();
		  List< List<Char>^ >^ worlds_t = gcnew List< List<Char>^ >();
		  List<double>^ prob_t = gcnew List<double>();

		  s2->enumerate( worlds_s, prob_s );
		  t2->enumerate( worlds_t, prob_t );
		  
		  return d.ExactExpectedDistance( worlds_s, worlds_t, prob_s, prob_t );
	}

	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble preEED1( SqlTypes::SqlString s, SqlTypes::SqlString t, int k ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		  if( d.EEDUpperBound( s2, t2 ) < (unsigned int) k )
			  return 0;
		  if( d.lbqgramdp( 2, s2, t2 ) > (unsigned int) k )
			  return k + 1;

		  return 0;
		  
	}

	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble preEED2( SqlTypes::SqlString s, SqlTypes::SqlString t, int k ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		  if( d.lbqgramdp( 2, s2, t2 ) > (unsigned int) k )
			  return k + 1;
		  if( d.EEDUpperBound( s2, t2 ) < (unsigned int) k )
			  return 0;


		  return 0;
		  
	}

	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble preEED3( SqlTypes::SqlString s, SqlTypes::SqlString t, int k ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		  if( d.EEDUpperBound( s2, t2 ) < (unsigned int) k )
			  return 0;
		  return k + 1;
	  
	}

	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble preEED4( SqlTypes::SqlString s, SqlTypes::SqlString t, int k ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		  return d.EEDUpperBound( s2, t2 );
	}

	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble preEED5( SqlTypes::SqlString s, SqlTypes::SqlString t, int k ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		  return d.MinEditDistance( s2, t2 );

		  			  return k + 1;

		  return 0;
	}

	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlDouble preEED6( SqlTypes::SqlString s, SqlTypes::SqlString t, int k ) {
		  prob_string^ s2 = s2->to_prob_string( s );
		  prob_string^ t2 = t2->to_prob_string( t );


		  ED d;
		  if( d.MinEditDistance( s2, t2 ) > (unsigned int) k )
			  return k + 1;
		  if( d.EEDUpperBound( s2, t2 ) < (unsigned int) k )
			  return k+1;


		  return 0;
		  
	}


	[Microsoft::SqlServer::Server::SqlFunction]
	  static SqlTypes::SqlString test( SqlTypes::SqlString s ) {
		  prob_string^ s2 = s2->to_prob_string( s );

		  List< List<Char>^ >^ worlds_s = gcnew List< List<Char>^ >();
		  List<double>^ prob_s = gcnew List<double>();

		  s2->enumerate( worlds_s, prob_s );

		  String^ ss = gcnew String(worlds_s[0]->ToArray());
		  return ss;
	}
};
