// Coded by Jeffrey Jestes
// jestes@cs.fsu.edu

// aggregate udf UBtau

#include "stdafx.h"
#include "type.cpp"

#define ARR_SIZE2 4
#define MAX_CHOICE2 2

#define ARR_SIZE4 16
#define MAX_CHOICE4 4

#define ARR_SIZE6 36
#define MAX_CHOICE6 6

#define ARR_SIZE8 64
#define MAX_CHOICE8 8

#define ARR_SIZE10 100
#define MAX_CHOICE10 10

#define MAX_BYTE 8000


using namespace System;
using namespace System::Data;
using namespace System::IO;
using namespace System::Data::Sql;
using namespace System::Data::SqlTypes;
using namespace System::Collections::Generic;
using namespace Microsoft::SqlServer::Server;

// In order to debug your Aggregate, add the following to your debug.sql file:
//
// if object_id ('test_table') is not null
//	DROP TABLE test_table

// CREATE TABLE test_table ( Column1 nvarchar(max))
// INSERT INTO test_table values (N'a')

// select dbo.Aggregate1(Column1) from test_table

public ref class id : IComparer<id^>

{
public:
	unsigned short ws;
	Byte count1;
	Byte count2;

	virtual int Compare( id^ x, id^ y ) {
		int xcount1 = x->count1;
		int xcount2 = x->count2;
		int ycount1 = y->count1;
		int ycount2 = y->count2;
		int xs;
		int ys;
		xs = xcount1 - xcount2;
		ys = ycount1 - ycount2;
		if( xs == ys ) return 0;
		if( xs > ys ) return -1;
		return 1;
	}
};

[Serializable]
[Microsoft::SqlServer::Server::SqlUserDefinedAggregate(Format::UserDefined,MaxByteSize=MAX_BYTE)]
public value struct UBt2 : IBinarySerialize
{    
public:
	void Init()
	{
		// TODO: Put your code here
		xs = gcnew List<id^>(ARR_SIZE2);
		for( int i = 0; i < ARR_SIZE2; ++i ) {
			xs->Add(gcnew id);
			xs[i]->ws = 0;
			xs[i]->count1=0;
			xs[i]->count2=0;
		}
	}
	
	void Accumulate(Type1 t)
	{
		// TODO: Put your code here
		int index = ( t.rcid - 1 ) * MAX_CHOICE2;
		index = index + ( t.tcid - 1 );

		if( index < ARR_SIZE2 ) {
			xs[index]->ws =  (unsigned short) ( t.rp *  t.tp * 10000 );
			int dist;
			if( t.rpos > t.tpos ) dist = t.rpos - t.tpos;
			else dist = t.tpos - t.rpos;
			if( dist <= (2 * t.tau) - 1 ) xs[index]->count2 += 1;
		     xs[index]->count1 += 1;
		}

	}

	void Merge(UBt2 Group)
	{
		// TODO: Put your code here

		for( int i = 0; i < ARR_SIZE2; ++i ) {
			xs[i]->count1 += Group.xs[i]->count1;
			xs[i]->count2 += Group.xs[i]->count2;
			if( xs[i]->ws == 0 ) xs[i]->ws = Group.xs[i]->ws;
		}
	}

	SqlTypes::SqlSingle Terminate()
	{
		float result = 0;
		float xsprime = 0;
		float wsprime = 0;
		float sum1 = 0;
		float sum2 = 0;
		float term3 = 0;
		float ws_sum = 0;
		float ws;
		int cc;



		id^ temp = gcnew id;
		xs->Sort(temp);



		int i;
		for( i = 0; i < ARR_SIZE2 && ws_sum < 0.50; ++i ) {

			ws = ( ( float) xs[i]->ws / ( float ) 10000 );
			cc = (int) xs[i]->count1 - (int) xs[i]->count2;

			ws_sum += ws;
			xsprime = (float) cc;
			wsprime = ws;
			sum1 += ws * xs[i]->count2;
			sum2 += ws * cc;
		}

		for( ; i < ARR_SIZE2; ++i ) {
			ws = ( ( float) xs[i]->ws / ( float ) 10000 );
			sum1 += ws * xs[i]->count2;
		}

		term3 = (float)(ws_sum - 0.50) * xsprime;

		result = sum1 + sum2 - term3;

		return result;
	}

	void virtual Read( BinaryReader^ r ) {
		xs = gcnew List<id^>(ARR_SIZE2);
		for( int i = 0; i < ARR_SIZE2; ++i ) {
			xs->Add(gcnew id);
			xs[i]->ws =  r->ReadUInt16();
			xs[i]->count1= r->ReadByte();
			xs[i]->count2= r->ReadByte();
		}
	}

	void virtual Write( BinaryWriter^ w ) {
		for( int i = 0; i < ARR_SIZE2; ++i ) {
			w->Write( xs[i]->ws );
			w->Write( xs[i]->count1 );
			w->Write( xs[i]->count2 );
		}

	}

private:

	List<id^>^ xs;
};


[Serializable]
[Microsoft::SqlServer::Server::SqlUserDefinedAggregate(Format::UserDefined,MaxByteSize=MAX_BYTE)]
public value struct UBt4 : IBinarySerialize
{    
public:
	void Init()
	{
		// TODO: Put your code here
		xs = gcnew List<id^>(ARR_SIZE4);
		for( int i = 0; i < ARR_SIZE4; ++i ) {
			xs->Add(gcnew id);
			xs[i]->ws = 0;
			xs[i]->count1=0;
			xs[i]->count2=0;
		}
	}
	
	void Accumulate(Type1 t)
	{
		// TODO: Put your code here
		int index = ( t.rcid - 1 ) * MAX_CHOICE4;
		index = index + ( t.tcid - 1 );

		if( index < ARR_SIZE4 ) {
			xs[index]->ws =  (unsigned short) ( t.rp *  t.tp * 10000 );
			int dist;
			if( t.rpos > t.tpos ) dist = t.rpos - t.tpos;
			else dist = t.tpos - t.rpos;
			if( dist <= (2 * t.tau) - 1 ) xs[index]->count2 += 1;
		     xs[index]->count1 += 1;
		}

	}

	void Merge(UBt4 Group)
	{
		// TODO: Put your code here

		for( int i = 0; i < ARR_SIZE4; ++i ) {
			xs[i]->count1 += Group.xs[i]->count1;
			xs[i]->count2 += Group.xs[i]->count2;
			if( xs[i]->ws == 0 ) xs[i]->ws = Group.xs[i]->ws;
		}
	}

	SqlTypes::SqlSingle Terminate()
	{
		float result = 0;
		float xsprime = 0;
		float wsprime = 0;
		float sum1 = 0;
		float sum2 = 0;
		float term3 = 0;
		float ws_sum = 0;
		float ws;
		int cc;



		id^ temp = gcnew id;
		xs->Sort(temp);



		int i;
		for( i = 0; i < ARR_SIZE4 && ws_sum < 0.50; ++i ) {

			ws = ( ( float) xs[i]->ws / ( float ) 10000 );
			cc = (int) xs[i]->count1 - (int) xs[i]->count2;

			ws_sum += ws;
			xsprime = (float)cc;
			wsprime = ws;
			sum1 += ws * xs[i]->count2;
			sum2 += ws * cc;
		}

		for( ; i < ARR_SIZE4; ++i ) {
			ws = ( ( float) xs[i]->ws / ( float ) 10000 );
			sum1 += ws * xs[i]->count2;
		}

		term3 = (float)(ws_sum - 0.50) * xsprime;

		result = sum1 + sum2 - term3;

		return result;
	}

	void virtual Read( BinaryReader^ r ) {
		xs = gcnew List<id^>(ARR_SIZE4);
		for( int i = 0; i < ARR_SIZE4; ++i ) {
			xs->Add(gcnew id);
			xs[i]->ws =  r->ReadUInt16();
			xs[i]->count1= r->ReadByte();
			xs[i]->count2= r->ReadByte();
		}
	}

	void virtual Write( BinaryWriter^ w ) {
		for( int i = 0; i < ARR_SIZE4; ++i ) {
			w->Write( xs[i]->ws );
			w->Write( xs[i]->count1 );
			w->Write( xs[i]->count2 );
		}

	}

private:

	List<id^>^ xs;
};

[Serializable]
[Microsoft::SqlServer::Server::SqlUserDefinedAggregate(Format::UserDefined,MaxByteSize=MAX_BYTE)]
public value struct UBt6 : IBinarySerialize
{    
public:
	void Init()
	{
		// TODO: Put your code here
		xs = gcnew List<id^>(ARR_SIZE6);
		for( int i = 0; i < ARR_SIZE6; ++i ) {
			xs->Add(gcnew id);
			xs[i]->ws = 0;
			xs[i]->count1=0;
			xs[i]->count2=0;
		}
	}
	
	void Accumulate(Type1 t)
	{
		// TODO: Put your code here
		int index = ( t.rcid - 1 ) * MAX_CHOICE6;
		index = index + ( t.tcid - 1 );

		if( index < ARR_SIZE6 ) {
			xs[index]->ws =  (unsigned short) ( t.rp *  t.tp * 10000 );
			int dist;
			if( t.rpos > t.tpos ) dist = t.rpos - t.tpos;
			else dist = t.tpos - t.rpos;
			if( dist <= (2 * t.tau) - 1 ) xs[index]->count2 += 1;
		     xs[index]->count1 += 1;
		}

	}

	void Merge(UBt6 Group)
	{
		// TODO: Put your code here

		for( int i = 0; i < ARR_SIZE6; ++i ) {
			xs[i]->count1 += Group.xs[i]->count1;
			xs[i]->count2 += Group.xs[i]->count2;
			if( xs[i]->ws == 0 ) xs[i]->ws = Group.xs[i]->ws;
		}
	}

	SqlTypes::SqlSingle Terminate()
	{
		float result = 0;
		float xsprime = 0;
		float wsprime = 0;
		float sum1 = 0;
		float sum2 = 0;
		float term3 = 0;
		float ws_sum = 0;
		float ws;
		int cc;



		id^ temp = gcnew id;
		xs->Sort(temp);



		int i;
		for( i = 0; i < ARR_SIZE6 && ws_sum < 0.50; ++i ) {

			ws = ( ( float) xs[i]->ws / ( float ) 10000 );
			cc = (int) xs[i]->count1 - (int) xs[i]->count2;

			ws_sum += ws;
			xsprime = (float)cc;
			wsprime = ws;
			sum1 += ws * xs[i]->count2;
			sum2 += ws * cc;
		}

		for( ; i < ARR_SIZE6; ++i ) {
			ws = ( ( float) xs[i]->ws / ( float ) 10000 );
			sum1 += ws * xs[i]->count2;
		}

		term3 = (float)(ws_sum - 0.50) * xsprime;

		result = sum1 + sum2 - term3;

		return result;
	}

	void virtual Read( BinaryReader^ r ) {
		xs = gcnew List<id^>(ARR_SIZE6);
		for( int i = 0; i < ARR_SIZE6; ++i ) {
			xs->Add(gcnew id);
			xs[i]->ws =  r->ReadUInt16();
			xs[i]->count1= r->ReadByte();
			xs[i]->count2= r->ReadByte();
		}
	}

	void virtual Write( BinaryWriter^ w ) {
		for( int i = 0; i < ARR_SIZE6; ++i ) {
			w->Write( xs[i]->ws );
			w->Write( xs[i]->count1 );
			w->Write( xs[i]->count2 );
		}

	}

private:

	List<id^>^ xs;
};

[Serializable]
[Microsoft::SqlServer::Server::SqlUserDefinedAggregate(Format::UserDefined,MaxByteSize=MAX_BYTE)]
public value struct UBt8 : IBinarySerialize
{    
public:
	void Init()
	{
		// TODO: Put your code here
		xs = gcnew List<id^>(ARR_SIZE8);
		for( int i = 0; i < ARR_SIZE8; ++i ) {
			xs->Add(gcnew id);
			xs[i]->ws = 0;
			xs[i]->count1=0;
			xs[i]->count2=0;
		}
	}
	
	void Accumulate(Type1 t)
	{
		// TODO: Put your code here
		int index = ( t.rcid - 1 ) * MAX_CHOICE8;
		index = index + ( t.tcid - 1 );

		if( index < ARR_SIZE8 ) {
			xs[index]->ws =  (unsigned short) ( t.rp *  t.tp * 10000 );
			int dist;
			if( t.rpos > t.tpos ) dist = t.rpos - t.tpos;
			else dist = t.tpos - t.rpos;
			if( dist <= (2 * t.tau) - 1 ) xs[index]->count2 += 1;
		     xs[index]->count1 += 1;
		}

	}

	void Merge(UBt8 Group)
	{
		// TODO: Put your code here

		for( int i = 0; i < ARR_SIZE8; ++i ) {
			xs[i]->count1 += Group.xs[i]->count1;
			xs[i]->count2 += Group.xs[i]->count2;
			if( xs[i]->ws == 0 ) xs[i]->ws = Group.xs[i]->ws;
		}
	}

	SqlTypes::SqlSingle Terminate()
	{
		float result = 0;
		float xsprime = 0;
		float wsprime = 0;
		float sum1 = 0;
		float sum2 = 0;
		float term3 = 0;
		float ws_sum = 0;
		float ws;
		int cc;



		id^ temp = gcnew id;
		xs->Sort(temp);



		int i;
		for( i = 0; i < ARR_SIZE8 && ws_sum < 0.50; ++i ) {

			ws = ( ( float) xs[i]->ws / ( float ) 10000 );
			cc = (int) xs[i]->count1 - (int) xs[i]->count2;

			ws_sum += ws;
			xsprime = (float)cc;
			wsprime = ws;
			sum1 += ws * xs[i]->count2;
			sum2 += ws * cc;
		}

		for( ; i < ARR_SIZE8; ++i ) {
			ws = ( ( float) xs[i]->ws / ( float ) 10000 );
			sum1 += ws * xs[i]->count2;
		}

		term3 = (float) (ws_sum - 0.50) * xsprime;

		result = sum1 + sum2 - term3;

		return result;
	}

	void virtual Read( BinaryReader^ r ) {
		xs = gcnew List<id^>(ARR_SIZE8);
		for( int i = 0; i < ARR_SIZE8; ++i ) {
			xs->Add(gcnew id);
			xs[i]->ws =  r->ReadUInt16();
			xs[i]->count1= r->ReadByte();
			xs[i]->count2= r->ReadByte();
		}
	}

	void virtual Write( BinaryWriter^ w ) {
		for( int i = 0; i < ARR_SIZE8; ++i ) {
			w->Write( xs[i]->ws );
			w->Write( xs[i]->count1 );
			w->Write( xs[i]->count2 );
		}

	}

private:

	List<id^>^ xs;
};

[Serializable]
[Microsoft::SqlServer::Server::SqlUserDefinedAggregate(Format::UserDefined,MaxByteSize=MAX_BYTE)]
public value struct UBt10 : IBinarySerialize
{    
public:
	void Init()
	{
		// TODO: Put your code here
		xs = gcnew List<id^>(ARR_SIZE10);
		for( int i = 0; i < ARR_SIZE10; ++i ) {
			xs->Add(gcnew id);
			xs[i]->ws = 0;
			xs[i]->count1=0;
			xs[i]->count2=0;
		}
	}
	
	void Accumulate(Type1 t)
	{
		// TODO: Put your code here
		int index = ( t.rcid - 1 ) * MAX_CHOICE10;
		index = index + ( t.tcid - 1 );

		if( index < ARR_SIZE10 ) {
			xs[index]->ws =  (unsigned short) ( t.rp *  t.tp * 10000 );
			int dist;
			if( t.rpos > t.tpos ) dist = t.rpos - t.tpos;
			else dist = t.tpos - t.rpos;
			if( dist <= (2 * t.tau) - 1 ) xs[index]->count2 += 1;
		     xs[index]->count1 += 1;
		}

	}

	void Merge(UBt10 Group)
	{
		// TODO: Put your code here

		for( int i = 0; i < ARR_SIZE10; ++i ) {
			xs[i]->count1 += Group.xs[i]->count1;
			xs[i]->count2 += Group.xs[i]->count2;
			if( xs[i]->ws == 0 ) xs[i]->ws = Group.xs[i]->ws;
		}
	}

	SqlTypes::SqlSingle Terminate()
	{
		float result = 0;
		float xsprime = 0;
		float wsprime = 0;
		float sum1 = 0;
		float sum2 = 0;
		float term3 = 0;
		float ws_sum = 0;
		float ws;
		int cc;



		id^ temp = gcnew id;
		xs->Sort(temp);



		int i;
		for( i = 0; i < ARR_SIZE10 && ws_sum < 0.50; ++i ) {

			ws = ( ( float) xs[i]->ws / ( float ) 10000 );
			cc = (int) xs[i]->count1 - (int) xs[i]->count2;

			ws_sum += ws;
			xsprime = cc;
			wsprime = ws;
			sum1 += ws * xs[i]->count2;
			sum2 += ws * cc;
		}

		for( ; i < ARR_SIZE10; ++i ) {
			ws = ( ( float) xs[i]->ws / ( float ) 10000 );
			sum1 += ws * xs[i]->count2;
		}

		term3 = (ws_sum - 0.50) * xsprime;

		result = sum1 + sum2 - term3;

		return result;
	}

	void virtual Read( BinaryReader^ r ) {
		xs = gcnew List<id^>(ARR_SIZE10);
		for( int i = 0; i < ARR_SIZE10; ++i ) {
			xs->Add(gcnew id);
			xs[i]->ws =  r->ReadUInt16();
			xs[i]->count1= r->ReadByte();
			xs[i]->count2= r->ReadByte();
		}
	}

	void virtual Write( BinaryWriter^ w ) {
		for( int i = 0; i < ARR_SIZE10; ++i ) {
			w->Write( xs[i]->ws );
			w->Write( xs[i]->count1 );
			w->Write( xs[i]->count2 );
		}

	}

private:

	List<id^>^ xs;
};