// coded by Jeffrey Jestes
// jestes@cs.fsu.edu

/* take the genome file and create a DB with deterministic strings as well as 2-grams
   use approximate string joining techniques to create similarity set */

#include <iostream>
#include <vector>
#include <cstdlib>
#include "prob_string.h"

using namespace std;


double abs( double a  ) {
   if( a < 0 ) return -a;
   return a;
}

int main( int argc, char** argv ) {

   if( argc != 3 ) {
      cout << "Usage: " << argv[0] << ' ' << "<min_string_length> <max_string_length>" << endl;
      exit( 0 );
   }


   unsigned int min_string_length = atoi( argv[1] );
   unsigned int max_string_length = atoi( argv[2] );
 
   vector< char > c;
   vector< vector<char> > grams;
   srand( time(0 ) );

   char d;
   unsigned long id = 1;
   unsigned int count = 0;
   unsigned int p = rand() % ( max_string_length - min_string_length + 1 );
   unsigned int len = min_string_length + p;
   while ( cin >> d ) {
      ++count;
      c.push_back( d );
      if( count >= len ) {
         cout << id << ',' << c.size() << ',';
         for( unsigned int i = 0; i < c.size(); ++i ) {
            cout << c[i];
         }
         cout << "\r\n";
         
         prob_string x;
         x.QGRAMS( c, grams );
         for( unsigned int i = 0; i < grams.size(); ++i ) {
            cerr << id << ',' << i << ',';
            for( unsigned int j = 0; j < grams[i].size(); ++j ) {
               cerr << grams[i][j];
            }
            cerr << ',' << c.size() << "\r\n";
         }

         p = rand() % ( max_string_length - min_string_length + 1 );
         len = min_string_length + p;
         c.clear();
         grams.clear();
         ++id;
         count = 0;
      }
      
   }

   return 0;
}
